#!/usr/bin/env python

# Define where is the file to open
import sys
sys.argv=["","GSM_List.txt"]

# Import used libraries
import urllib.request
import re

# Define function to clean html tags
def clean_html(html):
    """
    Remove HTML markup from the given string.
    :param html: the HTML string to be cleaned
    :type html: str
    :rtype: str
    """
    # First we remove inline JavaScript/CSS:
    cleaned = re.sub(r"(?is)<(script|style).*?>.*?(</\1>)", "", html.strip())
    # Then we remove html comments. This has to be done before removing regular
    # tags since comments can contain '>' characters.
    cleaned = re.sub(r"(?s)<!--(.*?)-->[\n]?", "", cleaned)
    # Next we can remove the remaining tags:
    cleaned = re.sub(r"(?s)<.*?>", " ", cleaned)
    # Finally, we deal with whitespace
    cleaned = re.sub(r"&nbsp;", " ", cleaned)
    cleaned = re.sub(r"  ", " ", cleaned)
    cleaned = re.sub(r"  ", " ", cleaned)
    # Remove first lines
    p=re.compile("(GEO Accession viewer\s*)", re.DOTALL)
    cleaned = p.sub("",cleaned)
    return cleaned.strip()

# Define function to dowload GSM files from GEO
def download(geo_file):
        address = "http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?view=data&acc=" + GSM
        page = urllib.request.urlopen(address).read().decode("utf-8")
        name_file = GSM + ".txt"
        raw = clean_html(page).replace("GEO Accession viewer\n  \n  \n \n\n \n \n \n","")
        gsm_file = open(name_file, "w")
        gsm_file.write(raw)
        gsm_file.close()

# Open and split the file with GSM accession number list by elements
gsm_list = (open(sys.argv[1],"r").read()).split()

# Analyse the list and download the files
for elem in gsm_list:
        if "..." in elem: # If GSM1...GSM7
                start = int(elem.split("...")[0][3:])
                end = int(elem.split("...")[1][3:]) 
                series = start
                while series <= end:
                        GSM = "GSM" + str(series)
                        download(GSM)
                        series+=1
        else:
                GSM = elem
                download(GSM)

print("Download completed")


